Attribute VB_Name = "Module1"
'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.

'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source!

' ---------------------------------------------------
' DateTime  : 16.10.2003
' Author    : (softKUS)
' ---------------------------------------------------

Option Explicit

Private Const S_OK As Long = 0
Private Const BI_RGB As Long = 0
Private Const DIB_RGB_COLORS As Long = 0
Private Const IID_IPicture As String = "{7BF80980-BF32-101A-8BBB-00AA00300CAB}"

' udt: Windows-Bitmap-Struktur
'      -> Einlesen der Bildinformationen
'         mit GDI_GetObject()
Private Type BITMAP
    bmType As Long
    bmWidth As Long
    bmHeight As Long
    bmWidthBytes As Long
    bmPlanes As Integer
    bmBitsPixel As Integer
    bmBits As Long
End Type

' udt: Windows-Bitmap-Struktur
'      -> Erstellen von Bildern im Speicher,
'         mit GDI_CreateDibSection
'      -> Einlesen von Bilddaten (binr)
'         mit GDI_GetDiBits
'
'      wird nur als Unterstruktur von
'      BITMAPINFO bentigt (s.u.)
Private Type BITMAPINFOHEADER
    biSize As Long
    biWidth As Long
    biHeight As Long
    biPlanes As Integer
    biBitCount As Integer
    biCompression As Long
    biSizeImage As Long
    biXPelsPerMeter As Long
    biYPelsPerMeter As Long
    biClrUsed As Long
    biClrImportant As Long
End Type

' udt: Windows-Bitmap-Struktur
Private Type BITMAPINFO
    bmiHeader As BITMAPINFOHEADER
    bmiColors As Long
End Type

' udt: PictureDescription
'      -> Erstellen eines IPicture-Objektes
'         mit OleCreatePictureIndirect
Private Type PictDesc
    cbSizeofStruct As Long
    picType As Long
    hImage As Long
    xExt As Long
    yExt As Long
End Type


' GDI (graphical device interface)

' Handle auf Fenster-Gertekontext
Private Declare Function GetDC Lib "user32" _
    (ByVal hWnd As Long) As Long
    
Private Declare Function GetDesktopWindow Lib "user32.dll" () As Long

' Freigeben eines Gertekontextes
Private Declare Function ReleaseDC Lib "user32" _
    (ByVal hWnd As Long, _
     ByVal hdc As Long) As Long
        
' Erstellen eines kompatiblen Gertekontextes
Private Declare Function CreateCompatibleDC Lib "gdi32" _
    (ByVal hdc As Long) As Long

' Lschen eines Gertekontextes
Private Declare Function DeleteDC Lib "gdi32" _
    (ByVal hdc As Long) As Long

' Einlesen von Informationen ber GDI-Objekte (z.B. Bilder)
Private Declare Function GetObjectA Lib "gdi32" _
    (ByVal hObject As Long, _
     ByVal nCount As Long, _
     ByRef lpObject As Any) As Long

' Erstellen eines gerte-unabhngigen Bildes (Device Independent Bitmap, DIB)
Private Declare Function CreateDIBSection Lib "gdi32" _
    (ByVal hdc As Long, _
     ByRef pbmi As BITMAPINFO, _
     ByVal iUsage As Long, _
     ByRef ppvBits As Long, _
     ByVal hSection As Long, _
     ByVal dwOffset As Long) As Long

' Selektieren eines GDI-Objektes
Private Declare Function SelectObject Lib "gdi32" _
    (ByVal hdc As Long, _
     ByVal hObject As Long) As Long

' Lschen eines GDI-Objektes
Private Declare Function DeleteObject Lib "gdi32" _
    (ByVal hObject As Long) As Long


' OLE (Object Linked Embedding, heute: COM oder ActiveX genannt)

' Umwandeln eines CLSID-Strings in Binrcode
Private Declare Function CLSIDFromString Lib "ole32" _
    (ByVal lpszProgID As Long, _
     ByVal pCLSID As Long) As Long

' Erstellen eines IPicture-Objektes aus einem GDI-Bitmap-Handle
Private Declare Function CreatePic Lib "olepro32" Alias "OleCreatePictureIndirect" _
    (ByRef lpPictDesc As PictDesc, _
     ByVal riid As Long, _
     ByVal fPictureOwnsHandle As Long, _
     ByRef ipic As IPicture) As Long

Function chgBPP(src As PictureBox, tgt As PictureBox, _
                Optional BPP As Long = 24, Optional etx As String) As Boolean
    
    Dim pic As StdPicture
    Dim bmp As BITMAP
    Dim bmi As BITMAPINFO
    Dim dsc As PictDesc
    Dim hD1 As Long
    Dim hD2 As Long
    Dim hSV As Long
    Dim ptr As Long
    Dim iid(15) As Byte
    
    If src.Picture.Handle = 0 Then
        etx = "Kein Bild geladen"
        
    ElseIf GetObjectA(src.Picture.Handle, Len(bmp), bmp) = 0 Then
        etx = "Bilddaten konnten nicht gelesen werden"
        
    Else
        ' per OLE-Funktion ein neues IPicture-Objekt erstellen
        dsc.cbSizeofStruct = Len(dsc)
        dsc.picType = vbPicTypeBitmap
        
        With bmi.bmiHeader
            .biSize = Len(bmi.bmiHeader)
            .biCompression = BI_RGB
            .biBitCount = BPP
            .biHeight = bmp.bmHeight
            .biWidth = bmp.bmWidth
            .biPlanes = 1
            .biSizeImage = ((.biWidth * BPP / 8 + 3) And -4) * .biHeight
    
            ' 1. Gertekontext
            hD1 = GetDC(GetDesktopWindow)
            If hD1 <> 0 Then hD2 = CreateCompatibleDC(hD1)
            
            ' 2. DIB-Section
            If hD2 <> 0 Then dsc.hImage = CreateDIBSection _
                (hD2, bmi, DIB_RGB_COLORS, ptr, 0, 0)
        
            If hD2 = 0 Then
                etx = "Gertekontext konnte nicht erzeugt werden"
            
            ElseIf dsc.hImage = 0 Or ptr = 0 Then
                etx = "Bildkopie konnte nicht erstellt werden"
            
            ' 3. IPicture-Objekt
            ElseIf CLSIDFromString(StrPtr(IID_IPicture), VarPtr(iid(0))) _
                <> S_OK Then
                
                etx = "OLE Fehler"
                
            Else
                hSV = SelectObject(hD2, dsc.hImage)
                Call src.Picture.Render( _
                    CLng(hD2), _
                    CLng(0), CLng(.biHeight - 1), _
                    CLng(.biWidth), CLng(Not .biHeight), _
                    0, 1 / (0.567 / Screen.TwipsPerPixelY), _
                    src.Picture.Width, src.Picture.Height, 0&)
                
                Call SelectObject(hD2, hSV)
            
                If CreatePic(dsc, VarPtr(iid(0)), True, pic) <> S_OK Then
                    etx = "OLE picture creation error"
                            
                Else
                    Set tgt.Picture = Nothing
                    Set tgt.Picture = pic
                    dsc.hImage = 0
                    chgBPP = True
                End If
            End If
        End With
    End If
    
    If dsc.hImage Then Call DeleteObject(dsc.hImage)
    
    If hD2 Then Call DeleteDC(hD2)
    If hD1 Then Call ReleaseDC(GetDesktopWindow, hD1)
End Function

